package de.unihannover.orderingExperimentAnalysis;

import java.io.IOException;
import java.util.Collection;
import java.util.Map.Entry;

import de.unihannover.orderingExperimentUi.Treatments;
import de.unihannover.orderingExperimentUi.Treatments.TreatmentCombination;
import de.unihannover.orderingExperimentUi.Treatments.TreatmentUsageData;

import java.util.Random;

public class PrintPrefill {

    public static void main(String[] args) throws Exception {
        try {
            print(AnalyzeExperimentLogs.getFiles());
        } catch (final Exception e) {
            System.out.println();
            e.printStackTrace(System.out);
        }
    }

    private static void print(String... filenames) throws IOException {
        final LogRecords log = LogRecords.load(filenames);
        final Collection<SessionData> sessions = log.getSplitByParticipant();

        sessions.removeIf(SessionData::isJeditIncomplete);
        sessions.removeIf(SessionData::isDuplicateParticipation);
        sessions.removeIf((SessionData s) -> !(s.isRealEffort(1) || s.isRealEffort(2)));

        final Treatments t = new Treatments(new Random(123));
        for (final SessionData s : sessions) {
            t.add(new TreatmentCombination(
                            de.unihannover.orderingExperimentUi.Treatment.valueOf(s.getTreatment(1).getLongForm()),
                            de.unihannover.orderingExperimentUi.Treatment.valueOf(s.getTreatment(2).getLongForm()),
                            s.getChange(1).toDiff(),
                            s.getChange(2).toDiff()),
                    1,
                    s.getDefectsFoundForReview(0));
        }

        for (final Entry<TreatmentCombination, TreatmentUsageData> e : t.getEntries().entrySet()) {
            System.out.println(e.getKey() + " " + e.getValue());
        }
    }

}
