package de.unihannover.orderingExperimentAnalysis;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import de.unihannover.orderingExperimentAnalysis.SessionData.Defect;

import java.util.Random;
import java.util.Set;
import java.util.TreeSet;

public class SampleRemarkSubset {

    private static Random r = new Random(23);

    public static void main(String[] args) {
        sample("_Warmup", 7, WU.getTrueDefects());
        sample("Patch 1", 15, P1.getTrueDefects());
        sample("Patch 2", 15, P2.getTrueDefects());
    }

    private static void sample(String prefix, int count, Map<String, List<Defect>> trueDefects) {
        final Multimap<Defect, String> remarksPerDefect = new Multimap<>();
        for (final Entry<String, List<Defect>> e : trueDefects.entrySet()) {
            for (final Defect d : e.getValue()) {
                remarksPerDefect.put(d, e.getKey());
            }
        }

        final Set<String> sample = new TreeSet<>();
        for (final Entry<Defect, List<String>> e : remarksPerDefect.getEntries()) {
            sample.add(sample(e.getValue()));
        }

        while (sample.size() < count) {
            sample.add(sample(trueDefects.keySet()));
        }

        for (final String remark : sample) {
            System.out.println(prefix + ": " + remark);
        }
    }

    private static String sample(Collection<String> collection) {
        if (collection instanceof List) {
            return sample((List<String>) collection);
        } else {
            return sample(new ArrayList<>(collection));
        }
    }

    private static String sample(List<String> list) {
        return list.get(r.nextInt(list.size()));
    }
}
